exp	: type.
id	: name_type.

var : id -> exp.
app : exp -> exp -> exp.
lam : id\exp -> exp.




pred token	A [A] [A].
token C (C::X) X.




pred exp 	[(char,id)] exp [char] [char].
pred id 	[(char,id)] id  [char] [char].
pred ws_opt 	[char] [char].
pred ws 	[char] [char].

pred find_first A [(A,B)] B.
find_first A [(A,B)|L] B.
find_first A [(B,_)|L] C :- not(A = B), find_first A L C.

id Env A --> token C, {find_first C Env A}.

ws --> ' ', ws_opt
    ;  '\t',ws_opt
    ;  '\n',ws_opt.
ws_opt --> {true}
	;  ws.

exp Env (app E1 E2) --> '(',ws_opt,exp Env E1,ws, exp Env E2,ws_opt,')'.
exp Env (var V) --> id Env (V).
exp Env (lam (x\E)) --> 
	'\\',ws_opt,
	token C,ws_opt,
	'.', ws_opt,
	exp [(C,x)|Env] E 
	/ x # Env.

pred parse_exp 	string exp.

parse_exp X E :- Y is X,
	             exp [] E Y [].



?parse_exp "\\x.\\y.(x y)" E.

?parse_exp "\\x.\\x.(x x)" E.
