
i	: type.
o	: type.
v	: name_type.
s	: name_type.

var	:  v -> i.
const	:  s -> i.
fun1	:  s -> i -> i.
fun2	:  s -> i -> i -> i.

t 	: o.
f	: o.
neg  	: o -> o.
and  	: o -> o -> o.
or   	: o -> o -> o.

eq    	: i -> i -> o.
prop  	: s -> o.
pred1 	: s -> i -> o.
pred2 	: s -> i -> i -> o.
all	: v\o -> o.
ex	: v\o -> o.

pred	quantifier_free	o.
pred	prenex_normal	o.
quantifier_free t.
quantifier_free f.
quantifier_free (prop P).
quantifier_free (pred1 P T).
quantifier_free (pred2 P T U).
quantifier_free (eq T U).
quantifier_free (neg P) :-  quantifier_free P.
quantifier_free (and P Q) :- quantifier_free P, quantifier_free Q.
quantifier_free (or P Q) :- quantifier_free P, quantifier_free Q.

prenex_normal t.
prenex_normal f.
prenex_normal (prop P).
prenex_normal (pred1 P T).
prenex_normal (pred2 P T U).
prenex_normal (eq T U).
prenex_normal (neg P) :-  quantifier_free P.
prenex_normal (and P Q) :- quantifier_free P, quantifier_free Q.
prenex_normal (or P Q) :- quantifier_free P, quantifier_free Q.
prenex_normal (all (x\P)) :- prenex_normal P.
prenex_normal (ex (x\P)) :- prenex_normal P.


pred	subst_i	(v\i) i i .
subst_i (a\var a) T T.
subst_i (a\var B) T (var B) :- a # B.
subst_i (a\const C) _ (const C).
subst_i (a\fun1 F T1) T (fun1 F T1') 
	:- subst_i (a\T1) T T1'.
subst_i (a\fun2 F T1 T2) T (fun2 F T1' T2') 
	:- subst_i (a\T1) T T1',
	subst_i (a\T2) T T2'.

pred	subst_o	(v\o) i o .
subst_o (a\t) _ t.
subst_o (a\f) _ f.
subst_o (a\prop P) _ (prop P).
subst_o (a\pred1 P T1) T (pred1 P T1') 
	:- subst_i (a\T1) T T1'.
subst_o (a\pred2 F T1 T2) T (pred2 F T1' T2') 
	:- subst_i (a\T1) T T1',
	subst_i (a\T2) T T2'.
subst_o (a\and P Q) T (and P' Q') 
	:- subst_o (a\P) T P', subst_o (a\P) T Q'.
subst_o (a\or P Q) T (or P' Q') 
	:- subst_o (a\P) T P', subst_o (a\P) T Q'.
subst_o (a\neg P) T (neg P') 
	:- subst_o (a\P) T P', subst_o (a\P) T Q'.
subst_o (a\eq T1 T2) T' (eq T1' T2') 
	:- subst_i (a\T1) T' T1',
        subst_i (a\T1) T' T1'.
subst_o (a\all (b\P)) T (all (b\T')) 
	/ b # T
	:- subst_o (a\P) T T'.
subst_o (a\ex (b\P)) T (ex (b\T')) 
	/ b # T
	:- subst_o (a\P) T T'.

pred	rewrite	o  o .
rewrite A A :- quantifier_free A.
rewrite (neg (all (x\P))) (ex (x\neg Q))
	:- rewrite P Q.
rewrite (neg (ex(x\P))) (all (x\neg Q))
	:- rewrite P Q.

rewrite (and (all (x\Q)) P) (all (x\R)) 
	/ x # P
	:- rewrite (and Q P) R.

rewrite (and P (all (x\Q))) (all (x\R)) 
	/ x # P
	:- rewrite (and P Q) R.
rewrite (and (ex (x\Q)) P) (ex (x\R)) 
	/ x # P
	:- rewrite (and Q P) R.
rewrite (and P (ex (x\Q))) (ex (x\R)) 
	/ x # P
	:- rewrite (and P Q) R.
rewrite (or (all (x\Q)) P) (all (x\R)) 
	/ x # P
	:- rewrite (or Q P) R.
rewrite (or P (all (x\Q))) (all (x\R)) 
	/ x # P
	:- rewrite (or P Q) R.
rewrite (or (ex (x\Q)) P) (ex (x\R)) 
	/ x # P
	:- rewrite (or Q P) R.
rewrite (or P (ex (x\Q))) (ex (x\R)) 
	/ x # P
	:- rewrite (or P Q) R.

rewrite (ex (y\P)) (ex (y\Q)) :- rewrite P Q.
rewrite (all (x\P)) (all (x\Q)) :- rewrite P Q.

?
rewrite (and (all (x\ ex (y\ eq (var x) (var y)))) 
	     (ex (x\ all (y\ eq (var x) (var y))))) P.

pred	rewrite'	o o.
	
rewrite' (and (all (x\P)) (all (x\Q))) (all (x\and P Q)).

?
rewrite' (and (all (x\ (ex (y\ pred2  p (var  x) (var  y))))) (all (y\ pred1  q (var y)))) Q.

pred	skolem	o o.
skolem (all (x\ ex (y\ P))) (all (x\ Q)) 
	/ g # P
	:- subst_o (y\P) (fun1 g (var  x)) Q.

?
skolem (all (x\ ex (y\ pred2  p (var  x) (var  y)))) Q.
