open Absyn;;
module N = Nstbl;;

type symk = VarS of ty | NameS of ty;;


let pp_symk symk = 
  match symk with
    NameS s -> pp_ty s
  | VarS s -> pp_ty s
;;


type tyk = DataKd | NameKd | TypeKd;;


let pp_tyk symk = 
  match symk with
    DataKd -> Printer.text "data"
  | NameKd -> Printer.text "atom"
  | TypeKd -> Printer.text "type"
;;


type ctx = symk Varmap.t;;


type tctx = tyk Varmap.t;;


type ty_abbrev = ty list -> ty;;


type ksg = (kind*Unique.uniq*ty_abbrev option) Nstbl.t;;



(* bool is whether it's a definition *)
type tsg = (bool*Unique.uniq*ty) N.t;; 


type sg = {ksg:ksg; tsg:tsg; stbl:(Unique.uniq, Nstbl.sym) Hashtbl.t};;


let init_sg () = 
  let sg = {ksg=Nstbl.create 100;tsg=Nstbl.create 100;stbl=Hashtbl.create 100} in
  sg

type eqns = (Types.var * Absyn.ty) list;;


type tcenv = Varset.t* tctx * ctx* eqns;;


(* Add built-in symbols *)
let empty_env = 
  let vs = Varset.empty in
  let tctx = Varmap.empty in
  let ctx = Varmap.empty in
  let eqns = [] in
  (vs,tctx,ctx,eqns)


