open Types;;
open Perm;;
open Internal;;
open Subst;;
open Printer;;

type 'a constrs = ('a term * var) list;;
type 'a answer  = ('a subst * 'a constrs);;

val pp_constrs : 'a printer -> 'a constrs printer;;
val pp_answer  : Tcenv.sg -> Tcenv.tcenv -> var list ->  
                 (Isym.term_sym answer) printer;;

type 'a sc_transform = ('a -> bool) -> ('a -> bool);;
type 'a equal = 'a -> 'a -> bool;;

val unify_fresh : 'a term -> 'a term -> ('a answer) sc_transform;;
val unify       : 'a equal -> 'a term -> 'a term -> ('a answer) sc_transform;;
val unifys      : 'a equal -> ('a term * 'a term) list -> 
                  ('a answer) sc_transform;;
