
exception Impos of string
exception Error of string
exception NYI

let error msg = raise (Error msg);;


let nyi () = raise NYI;;


let impos s = raise (Impos s);;


let debug = ref false;;


let do_trace i f = if !Flags.trace >= i then f();;


let nl () = print_string "\n";;


let split p s = 
  let n = String.length s in
  let rec tokenize i j = (* 0 <= i <= j <= n *)
    if j = n || p(String.get s i)
    then (String.sub s i (j-i))::skip j
    else (* j < n*) tokenize i (j+1)
  and skip j = (* 0 <= j <= n *)
    if j = n then []
    else if p(String.get s j) then skip(j+1)
    else tokenize j j
  in tokenize 0 0
;;
